#include "stdafx.h"
#include "TestApp.h"
#include "TestAppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CTestAppDlg::CTestAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestAppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestAppDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_imlNormal.Create( IDB_BMP_CTRLIMAGES, 16, 4, RGB(0, 0, 255) );
}

void CTestAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestAppDlg)
	DDX_Control(pDX, IDC_TREECTRLEX, m_TreeCtrlEx);
	DDX_Control(pDX, IDC_LISTCTRLEX, m_ListCtrlEx);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestAppDlg, CDialog)
	//{{AFX_MSG_MAP(CTestAppDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CTestAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	m_ListCtrlEx.InsertColumn( 0, "Column1", LVCFMT_LEFT, 200 );
	m_ListCtrlEx.SetExtendedStyle(LVS_EX_CHECKBOXES);
	CString tmpStr;
	
//	m_ListCtrlEx.SetComboMinMaxWidths( 250, 250 );
	for( int i = 0; i < 25; i++ )
	{
		int nItem = m_ListCtrlEx.InsertItemWithComboBox( "Item1", TRUE );
		for( int ii = 0; ii < 24; ii++ )
		{
			tmpStr.Format( "Item_%d", ii + 2 );
			m_ListCtrlEx.InsertComboBoxString( nItem, tmpStr );
		}
	}
	
	m_TreeCtrlEx.SetImageList( &m_imlNormal, TVSIL_STATE );
//	m_TreeCtrlEx.SetComboMinMaxWidths( 250, 250 );


	HTREEITEM hti;
	for( i = 0; i < 25; i++ )
	{
		hti = m_TreeCtrlEx.InsertItemWithComboBox( "Item_1", TRUE );
		m_TreeCtrlEx.SetItemState( hti, INDEXTOSTATEIMAGEMASK( 1 ), TVIS_STATEIMAGEMASK );
		for( int ii = 0; ii < 24; ii++ )
		{
			tmpStr.Format( "Item_%d", ii + 2 );
			m_TreeCtrlEx.InsertComboBoxString( hti, tmpStr );
		}

		for( int j = 0; j < 5; j++ )
		{
			hti = m_TreeCtrlEx.InsertItemWithComboBox( "SubItem_1", TRUE, hti );
			m_TreeCtrlEx.SetItemState( hti, INDEXTOSTATEIMAGEMASK( (j % 5) + 2 ), TVIS_STATEIMAGEMASK );
			for( int jj = 0; jj < 24; jj++ )
			{
				tmpStr.Format( "SubItem_%d", jj + 2 );
				m_TreeCtrlEx.InsertComboBoxString( hti, tmpStr );
			}
		}
	}

	return TRUE;
}

void CTestAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CTestAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
